/*
---
description: Simple draggable n-digits calculator with the following operations: +, -, *, /, %, pow, sqrt.

license: MIT-style

authors:
- abidibo <dev@abidibo.net>

requires:
- core/1.4.5
- more/1.4.0.1 Drag

provides:
- Calculator

...

For documentation, demo and download link please visit http://www.abidibo.net/projects/js/calculator

*/
var Calculator=new Class({Implements:[Options],options:{drag:true,anchor:null,digits:14},initialize:function(a){this.setOptions(a);this.render();this.addEvents();this.first_term=null;this.new_term=true;this.operation=null},getViewport:function(){var d=document.getCoordinates();var b=document.getScroll();var c=d.width;var a=d.height;var f=b.x;var e=b.y;var h=d.width/2+b.x;var g=d.height/2+b.y;return{width:c,height:a,left:f,top:e,cX:h,cY:g}},render:function(){var b=new Element("table").adopt(new Element("tr").adopt(new Element("td.operation").set("text","√"),new Element("td.operation").set("html","x<sup>y</sup>"),new Element("td.operation").set("text","%"),new Element("td.clear").set("text","CE")),new Element("tr").adopt(new Element("td.number").set("text","7"),new Element("td.number").set("text","8"),new Element("td.number").set("text","9"),new Element("td.operation").set("text","÷")),new Element("tr").adopt(new Element("td.number").set("text","4"),new Element("td.number").set("text","5"),new Element("td.number").set("text","6"),new Element("td.operation").set("text","×")),new Element("tr").adopt(new Element("td.number").set("text","1"),new Element("td.number").set("text","2"),new Element("td.number").set("text","3"),new Element("td.operation").set("text","-")),new Element("tr").adopt(new Element("td.number").set("text","0"),new Element("td.dot").set("text","."),new Element("td.equal").set("text","="),new Element("td.operation").set("text","+")));if(this.options.anchor){this.container=new Element("div#calculator").inject(document.id(this.options.anchor)).adopt(this.display=new Element("div#display").set("text",0),b)}else{var a=this.getViewport();this.container=new Element("div#calculator").inject(document.body).setStyles({position:"absolute",top:a.cY-150,left:a.cX-106}).adopt(this.display=new Element("div#display").set("text",0),b);if(this.options.drag){var d=document.getCoordinates();var c=new Drag(this.container,{limit:{x:[0,(d.width-this.container.getCoordinates().width)],y:[0]}})}}},addEvents:function(){this.container.addEvent("click",this.click.bind(this))},click:function(b){var c=b.target;if(c.get("class")=="equal"){var a=this.calculate();if(a!==null){this.display.set("text",a)}}else{if(c.get("class")=="clear"){this.clear()}else{if(c.get("class")=="operation"){var d=c.get("text");if(d=="-"&&(this.new_term&&(this.operation||this.first_term==null))){this.display.set("text","-");this.new_term=false;return null}if(d=="√"||d=="%"){if(this.operation){this.display.set("text",this.first_term=this.calculate())}else{this.first_term=parseFloat(this.display.get("text"))}this.operation=d;this.display.set("text",this.calculate());return null}if(this.first_term==null){this.first_term=parseFloat(this.display.get("text"))}else{this.display.set("text",this.first_term=this.calculate())}this.operation=d;this.new_term=true}else{if(c.get("class")=="number"||c.get("class")=="dot"){if(this.new_term){this.display.set("text",c.get("text"));this.new_term=false}else{if(this.display.get("text").length<this.options.digits&&(c.get("class")!="dot"||!/\./.test(this.display.get("text")))){this.display.appendText(c.get("text"))}}}}}}},clear:function(){this.first_term=null;this.operation=null;this.display.set("text",0);this.new_term=true},calculate:function(){if(this.first_term==null||this.operation==null){return null}this.second_term=parseFloat(this.display.get("text"));var a;if(this.operation=="√"){a=Math.sqrt(this.first_term)}else{if(this.operation=="%"){a=this.first_term/100}else{if(this.operation=="+"){a=this.first_term+this.second_term}else{if(this.operation=="-"){a=this.first_term-this.second_term}else{if(this.operation=="×"){a=this.first_term*this.second_term}else{if(this.operation=="÷"){a=this.first_term/this.second_term}else{if(this.operation=="xy"){a=Math.pow(this.first_term,this.second_term)}}}}}}}this.first_term=null;this.operation=null;return this.format(a)},format:function(a){var e=a.toString();var f=e.split(".");var c=f[0];var b=f.length==2?f[1]:null;if(c&&c.length>this.options.digits){return a.toExponential(this.options.digits-6>0?this.options.digits-6:0)}else{if(c&&b){if(c.length+b.length<this.options.digits){return e}else{if(c.length<this.options.digits){if(/e/.test(b)){return a.toExponential(this.options.digits-5-c.length>0?this.options.digits-5-c.length:0)}else{var d=Math.pow(10,(this.options.digits-1-c.length));return Math.round(a*d)/d}}else{if(c.length=this.options.digits){return Math.round(a)}}}}else{return e}}},remove:function(){this.container.destroy()},hide:function(){this.container.style.display="none"},show:function(){this.container.style.display="block"},toggle:function(){if(this.container.style.display=="none"){this.show()}else{this.hide()}}});
